/* Sistemas Integrados TECNISA
   Servios

Nome: LIMPA_PEDIDO

Descrio:
Limpa os dados dos Pedidos

@C:\WIN_PRJ\SQL\END_CONV\ORACLE\2830_PEDSTP_LIMPA_PEDIDO.SQL

Criao:
19/11/2002 - Andr Rodrigo */

CREATE OR REPLACE PROCEDURE LIMPA_PEDIDO
   (P_CDFILLISTA IN VARCHAR2,
    P_TCDFILIAL  IN VARCHAR2,
    P_NMOPERADOR IN OPERADOR.NMOPERADOR%TYPE,
    P_DSSISTEMA  IN VARCHAR2,
    P_DSLIMPEZA  IN VARCHAR2,
    P_DTPEDIDO   IN DATE,
    P_IDLIMPO OUT   VARCHAR2) AS

    V_CONTADOR    NUMBER;

BEGIN
   P_IDLIMPO := '0';

   /* DELETA OS PEDIDOS DE VENDAS */
   FOR CUR_PED IN
      (SELECT CDFILIAL,NRPEDIDO
       FROM   PEDIDO
       WHERE ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
              (TO_DATE(TO_CHAR(DTPEDIDO,'DD/MM/YYYY'),'DD/MM/YYYY') <= TO_DATE(TO_CHAR(P_DTPEDIDO,'DD/MM/YYYY'),'DD/MM/YYYY'))) LOOP

      /* DELETAR OS TENS DOS PEDIDOS */
      SELECT  COUNT(*)
      INTO    V_CONTADOR
      FROM    ITEMPRODUTO
      WHERE  CDFILIALPED = CUR_PED.CDFILIAL AND
             NRPEDIDO    = CUR_PED.NRPEDIDO;

      IF V_CONTADOR > 0 THEN
         P_IDLIMPO := '9';
      ELSE
         DELETE HISITEMPED
         WHERE (CDFILIAL = CUR_PED.CDFILIAL) AND
               (NRPEDIDO = CUR_PED.NRPEDIDO);

         DELETE PEDIDOP
         WHERE (CDFILIAL = CUR_PED.CDFILIAL) AND
               (NRPEDIDO = CUR_PED.NRPEDIDO);

         DELETE ITEMPEDIDO
         WHERE (CDFILIAL = CUR_PED.CDFILIAL) AND
               (NRPEDIDO = CUR_PED.NRPEDIDO);

         DELETE PARPEDIDO
         WHERE (CDFILIAL = CUR_PED.CDFILIAL) AND
               (NRPEDIDO = CUR_PED.NRPEDIDO);

         UPDATE PROITPROP
         SET NRPEDIDO = NULL
         WHERE (CDFILIAL = CUR_PED.CDFILIAL) AND
               (NRPEDIDO = CUR_PED.NRPEDIDO);

         DELETE PEDIDO
         WHERE (CDFILIAL = CUR_PED.CDFILIAL) AND
               (NRPEDIDO = CUR_PED.NRPEDIDO);
      END IF;
   END LOOP;

   IF SQL%ROWCOUNT <> 0 THEN
      INSERT INTO LOGLIMPEZA
         (DTLIMPDADOS, DSSISTLIMPEZ, NMOPERLIMPEZ,
          DTFINALIMPEZ, DSLIMPEZA)
       VALUES
          (SYSDATE, P_DSSISTEMA, P_NMOPERADOR,
           P_DTPEDIDO, P_DSLIMPEZA);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LIMPA_PEDIDO','4.05.125'); END;
/

