import Vue from 'vue';
import Router from 'vue-router';
import { Config } from '@zeedhi/core';
import { TekLibAuth } from '@zeedhi/tek-lib';
import routes from './routes';
// import Store from '../store';

Vue.use(Router);

const router = new Router({
  mode: 'history',
  base: Config.env.BASE_URL,
  routes,
});

router.beforeEach(async (to, from, next) => {
  TekLibAuth.setInitialData(to.path, Config.env.loginRoutePath);
  if (to.path !== Config.env.loginRoutePath && !localStorage.getItem('LOGIN_TOKEN')) {
    next(Config.env.loginRoutePath);
  } else if (to.path === Config.env.loginRoutePath && localStorage.getItem('LOGIN_TOKEN')) {
    next(Config.env.baseUrl);
  } else {
    next();
  }
});

// router.afterEach((to, from) => {
//   // const htmlElement = document.getElementsByTagName('html')[0];
//   // if (to.name === 'login') {
//   //   htmlElement.setAttribute('login', '');
//   // } else {
//   //   htmlElement.removeAttribute('login');
//   // }
// });

export default router;
